> This page is for version Generative (default).
> For other versions, use one of these documentation indexes:
> - Generative (default): https://developers.ada.cx/generative/llms.txt
> - Scripted: https://developers.ada.cx/scripted/llms.txt

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://developers.ada.cx/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://developers.ada.cx/_mcp/server.

# Get multiple end users

GET https://example.ada.support/api/v2/end-users/

Get multiple end users. You can specify how many users appear per page, and which user id to start from.

Reference: https://developers.ada.cx/reference/end-users/get-end-users

## Authentication

- `Authorization` header (bearer token, required) — Bearer authentication of the form `Bearer <token>`, where token is your auth token.

## Request

### Query parameters

- `cursor` (string, optional) — The id that marks the start or beginning of the returned records
- `limit` (integer, optional) — The number of records to return

## Response

### 200

OK

- `data` (list of EndUser, optional) — The list of end user profiles
- `meta` (CursorPaginationMetadata, optional) — Metadata returned with the results including but not limited to a link to the next page of data

## Types

### EndUser

- `end_user_id` (string, optional) — The unique Ada-generated id for the end user
- `profile` (EndUserProfile, optional) — The end user's profile information
- `created_at` (string, optional) — The date and time the end user was created
- `updated_at` (string, optional) — The date and time the end user was updated

### CursorPaginationMetadata

Metadata returned with the results including but not limited to a link to the next page of data

- `next_page_url` (string, optional) — Link to the next page of data using a cursor value

### EndUserProfile

The end user's profile information

- `first_name` (string, optional) — The end user's first name
- `last_name` (string, optional) — The end user's last name
- `display_name` (string, optional) — The end user's display name
- `avatar` (string, optional) — URL to the end user's avatar image
- `email` (string, optional) — The end user's email address
- `language` (string, optional) — The end user's language in BCP 47 format
- `metadata` (EndUserProfileMetadata, optional) — A dictionary of arbitrary key, value pairs assigned to the end user - `metadata` keys may only be of type: `string` - `metadata` values may only be one of type: `string`, `boolean`, or `integer`
- `system_properties` (EndUserProfileSystemProperties, optional) — Read-only profile information set by Ada

### EndUserProfileMetadata

A dictionary of arbitrary key, value pairs assigned to the end user - `metadata` keys may only be of type: `string` - `metadata` values may only be one of type: `string`, `boolean`, or `integer`

### EndUserProfileSystemProperties

Read-only profile information set by Ada

- `sunshine_user_id` (string, optional) — The Sunshine Conversations user id for the end user

## Examples

**Response**

```json
{
  "data": [
    {
      "end_user_id": "5f7e0e2c1e7c7e000f0f9c3a",
      "profile": {
        "first_name": "Ada",
        "last_name": "Lovelace",
        "display_name": "Ada Lovelace",
        "avatar": "https://example.com/avatars/ada.png",
        "email": "ada.lovelace@ada.cx",
        "language": "en-US",
        "metadata": {},
        "system_properties": {
          "sunshine_user_id": "5f7e0e2c1e7c7e000f0f9c3a"
        }
      },
      "created_at": "2020-09-20T00:00:00+00:00",
      "updated_at": "2020-09-20T00:00:00+00:00"
    }
  ],
  "meta": {
    "next_page_url": "https://example.ada.support/api/v2/end-users/?cursor=65a17e3f43bec88e2792d0eb"
  }
}
```

**SDK Code**

```python 
import requests

url = "https://example.ada.support/api/v2/end-users/"

querystring = {"cursor":"5f7e0e2c1e7c7e000f0f9c3a","limit":"10"}

headers = {"Authorization": "Bearer <token>"}

response = requests.get(url, headers=headers, params=querystring)

print(response.json())
```

```javascript 
const url = 'https://example.ada.support/api/v2/end-users/?cursor=5f7e0e2c1e7c7e000f0f9c3a&limit=10';
const options = {method: 'GET', headers: {Authorization: 'Bearer <token>'}};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go 
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://example.ada.support/api/v2/end-users/?cursor=5f7e0e2c1e7c7e000f0f9c3a&limit=10"

	req, _ := http.NewRequest("GET", url, nil)

	req.Header.Add("Authorization", "Bearer <token>")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby 
require 'uri'
require 'net/http'

url = URI("https://example.ada.support/api/v2/end-users/?cursor=5f7e0e2c1e7c7e000f0f9c3a&limit=10")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request["Authorization"] = 'Bearer <token>'

response = http.request(request)
puts response.read_body
```

```java 
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://example.ada.support/api/v2/end-users/?cursor=5f7e0e2c1e7c7e000f0f9c3a&limit=10")
  .header("Authorization", "Bearer <token>")
  .asString();
```

```php 
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://example.ada.support/api/v2/end-users/?cursor=5f7e0e2c1e7c7e000f0f9c3a&limit=10', [
  'headers' => [
    'Authorization' => 'Bearer <token>',
  ],
]);

echo $response->getBody();
```

```csharp 
using RestSharp;

var client = new RestClient("https://example.ada.support/api/v2/end-users/?cursor=5f7e0e2c1e7c7e000f0f9c3a&limit=10");
var request = new RestRequest(Method.GET);
request.AddHeader("Authorization", "Bearer <token>");
IRestResponse response = client.Execute(request);
```

```swift 
import Foundation

let headers = ["Authorization": "Bearer <token>"]

let request = NSMutableURLRequest(url: NSURL(string: "https://example.ada.support/api/v2/end-users/?cursor=5f7e0e2c1e7c7e000f0f9c3a&limit=10")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"
request.allHTTPHeaderFields = headers

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```